<div id="products" class="page-layout carded fullwidth" fusePerfectScrollbar>

  <!-- TOP BACKGROUND -->
  <div class="top-bg {{secondColorBrand}}"></div>
  <!-- / TOP BACKGROUND -->

  <!-- CENTER -->
  <div class="center">



    <!-- HEADER -->
    <div class="header white-fg" fxLayout="column" fxLayoutAlign="center center" fxLayout.gt-xs="row"
      fxLayoutAlign.gt-xs="space-between center">

      <!-- SEARCH -->

      <div class="h-90 w-100-p" style="padding-top: 30px;padding-bottom: 10px; height: 100px; ">

        <div class="search-wrapper" fxFlex fxLayout="row" fxLayoutAlign="start center" fxFlex="100">
          <!-- 
          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="30px">
            <div fxLayout="row" fxLayoutAlign="start center" fxFlex="100">
              <div fxFlex="60">
                <mat-button-toggle-group formControlName="viewType">
                  <mat-button-toggle value="TABLE" matTooltip="Tabela">
                    <mat-icon>table_chart</mat-icon>
                  </mat-button-toggle>
                  <mat-button-toggle value="DASHBOARD" matTooltip="Dashboard">
                    <mat-icon>dashboard</mat-icon>
                  </mat-button-toggle>
                </mat-button-toggle-group>
              </div>
            </div>
            
          </form> -->

          <!-- APP TITLE -->
          <div class="logo my-12 m-sm-0" fxLayout="row" fxLayoutAlign="start center" *ngIf="searchForm.value.viewType == 'DASHBOARD'"
            style="padding-right: 10%;">
            <span class="logo-text h1" *fuseIfOnDom [@animate]="{value:'*',params:{delay:'100ms',x:'-25px'}}">Dashboard</span>
          </div>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start start" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'DASHBOARD'">

            <mat-form-field fxFlex="85">
              <mat-select placeholder="Marca" (selectionChange)="onBrandsSelectionChange($event)">
                <mat-option *ngFor="let item of brandsList" [value]="item.id">
                  {{ item.name }}
                </mat-option>
              </mat-select>
              <div fxFlex="5"></div>

            </mat-form-field>

          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'DASHBOARD'">

            <mat-form-field fxFlex="90">
              <mat-select placeholder="Instalador" formControlName="technician" (selectionChange)="onListValueChanged()">
                  
                <mat-option *ngFor="let technician of technicianList" [value]="technician.id">
                  {{ technician.name }}
                </mat-option>
              </mat-select>

            </mat-form-field>
            <div fxFlex="10"></div>
          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'DASHBOARD'">

            <mat-form-field fxFlex="90">
              <mat-select placeholder="Operador" formControlName="technician" (selectionChange)="onListValueChanged()">
                <mat-option *ngFor="let technician of technicianList" [value]="technician.id">
                  {{ technician.name }}
                </mat-option>
              </mat-select>

            </mat-form-field>
            <div fxFlex="10"></div>
          </form>


          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'DASHBOARD'">
            <button mat-button class="px-16" [matMenuTriggerFor]="deviceMenu" *ngIf="searchForm.value.viewType == 'DASHBOARD'">
              Filtro Dashboard&nbsp;&nbsp;
              <mat-icon>arrow_drop_down</mat-icon>
            </button>

            <mat-menu #deviceMenu="matMenu">

              <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item *ngFor="let range of widgets.widget5.ranges | keys"
                (click)="widget5.currentRange = range.key" [disabled]="widget5.currentRange == range.key">

                <span>
                  <mat-icon>bar_chart</mat-icon>
                </span>
                <span>{{range.value}}</span>

              </button>

            </mat-menu>
          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="30px" *ngIf="searchForm.value.viewType == 'TABLE'">
            <div fxFlex="1"></div>
            <div fxFlex="4">
              <mat-icon>search</mat-icon>
            </div>
            <mat-form-field fxFlex="100">
              <input matInput placeholder="Buscar" formControlName="searchControl">
            </mat-form-field>
            
          </form>

          <!-- <tnm-search></tnm-search> -->

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'TABLE'">
            <div fxFlex="100"></div>
          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'TABLE'">

            <mat-form-field fxFlex="90">
              <mat-select placeholder="Tipo" formControlName="type" (selectionChange)="onListValueChanged()">
                <mat-option *ngFor="let type of serviceOrderTypeList" [value]="type.key">
                  {{ type.value }}
                </mat-option>
              </mat-select>
            </mat-form-field>
            <div fxFlex="10"></div>
          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'TABLE'">

            <mat-form-field fxFlex="90">
              <mat-select placeholder="Status" formControlName="status" (selectionChange)="onListValueChanged()">
                <mat-option [value]="0">TODOS</mat-option>
                <mat-option *ngFor="let status of serviceOrderStatusList" [value]="status.key">
                  {{ status.value }}
                </mat-option>
              </mat-select>
            </mat-form-field>
            <div fxFlex="10"></div>
          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'TABLE'">

            <mat-form-field fxFlex="90">
              <mat-select placeholder="Instalador" formControlName="technician" (selectionChange)="onListValueChanged()">
                <mat-option [value]="0">TODOS</mat-option>
                <mat-option *ngFor="let technician of technicianList" [value]="technician.id">
                  {{ technician.name }}
                </mat-option>
              </mat-select>

            </mat-form-field>
            <div fxFlex="10"></div>
          </form>

          <form [formGroup]="searchForm" novalidate fxFlex="100" fxLayoutAlign="start start" fxLayoutGap="10px" *ngIf="searchForm.value.viewType == 'TABLE'">

            <mat-form-field fxFlex="85">
              <mat-select placeholder="Marca" formControlName="brand" (selectionChange)="onBrandsSelectionChange($event)">
                <mat-option *ngFor="let item of brandsList" [value]="item.id">
                  {{ item.name }}
                </mat-option>
              </mat-select>
              <div fxFlex="5"></div>

            </mat-form-field>


          </form>

        </div>
      </div>
      <!-- / SEARCH -->

      <button type="button" mat-raised-button color="primary" *ngIf="searchForm.value.viewType == 'TABLE'" [ngClass]="primaryColorBrand"
        mat-button [routerLink]="['/service-orders/new']">NOVA
        OS</button>

    </div>
    <!-- / HEADER -->

    <!-- CONTENT CARD -->
    <div class="content-card mat-white-bg" *ngIf="searchForm.value.viewType == 'TABLE'">

      <mat-table class="products-table" #table [dataSource]="dataSource" [@animateStagger]="{value:'50'}"
        fusePerfectScrollbar matSort matSortActive="lifecycle.openDate" matSortDirection="asc" matSortDisableClear>

        <ng-container cdkColumnDef="statusColor">
          <mat-header-cell *cdkHeaderCellDef class="white-fg"></mat-header-cell>
          <mat-cell *cdkCellDef="let element" [ngClass]="checkPlus48Hours(element.lifecycle.openDate, element.status) ? dangerColor : serviceOrderColorEnumToString( element.serviceOrderStatus ? element.serviceOrderStatus : element.status)">

          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="space">
          <mat-header-cell *cdkHeaderCellDef class="white-fg"></mat-header-cell>
          <mat-cell *cdkCellDef="let element">

          </mat-cell>
        </ng-container>


        <ng-container cdkColumnDef="brand">
          <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Marca</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <p class="text-truncate">{{element.brandObj ? element.brandObj.name : '-'}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="licensePlate">
            <mat-header-cell *cdkHeaderCellDef class="white-fg">Placa</mat-header-cell>
            <mat-cell *cdkCellDef="let element">
              <p class="text-truncate">{{checkLicensePlate(element)}}</p>
            </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="customerName">
          <mat-header-cell *cdkHeaderCellDef class="white-fg">Cliente</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <p class="text-truncate">{{customerNameByServiceOrderType(element)}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="lifecycle.openDate">
          <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Criado em</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <p class="text-truncate">{{element.lifecycle.openDate | date: 'dd/MM/yyyy HH:mm'}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="type">
          <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Tipo</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <p class="text-truncate">{{element.serviceOrderType ? element.serviceOrderType : element.type}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="zipCode">
          <mat-header-cell *cdkHeaderCellDef class="white-fg">Cep</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <p class="text-truncate">{{(element.installation && element.installation.address) ?
              maskPostalCode(element.installation.address.postalCode) : '-'}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="scheduling">
          <mat-header-cell *cdkHeaderCellDef class="white-fg">Agendamento</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <p class="text-truncate">{{(element.installation && element.installation.scheduledDate)?
              (element.installation.scheduledDate | date: 'dd/MM/yyyy HH:mm') : '-'}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="status">
          <mat-header-cell *cdkHeaderCellDef mat-sort-header class="white-fg">Status</mat-header-cell>
          <mat-cell *cdkCellDef="let element">
            <mat-chip-list>
              <mat-chip [ngClass]="checkPlus48Hours(element.lifecycle.openDate,element.status) ? dangerColor : serviceOrderColorLightEnumToString(element.serviceOrderStatus ? element.serviceOrderStatus : element.status)"
                style="width: 100px; text-align: center;" selected> {{ element.pendency ? ( 'Dependência - ' +
                element.pendency.brand) : (element.serviceOrderStatus ? element.serviceOrderStatus : element.status)}}</mat-chip>
            </mat-chip-list>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="priority">
          <mat-header-cell *cdkHeaderCellDef class="white-fg">Prioridade</mat-header-cell>
          <mat-cell *cdkCellDef="let element" style="text-align: center">
            <p class="text-truncate" style="text-align: center; padding-left: 50px">{{element.priority ?
              element.priority : '-'}}</p>
          </mat-cell>
        </ng-container>

        <ng-container cdkColumnDef="pendency">
          <mat-header-cell *cdkHeaderCellDef class="white-fg"></mat-header-cell>
          <mat-cell *cdkCellDef="let element">
              <mat-icon *ngIf="checkPendencyType(element)"   class="logo-icon mr-16 red-fg" >warning</mat-icon>
          </mat-cell>
        </ng-container>

        <mat-header-row *matHeaderRowDef="displayedColumns" [ngClass]="primaryColorBrand"></mat-header-row>
        <mat-row *cdkRowDef="let row; columns: displayedColumns;" class="product" matRipple (click)="editServiceOrder(row)">
        </mat-row>
      </mat-table>

      <mat-paginator [length]="resultLength" [pageSize]="10" [pageSizeOptions]="[10, 30, 50]"></mat-paginator>

    </div>

    <div class="content-card mat-white-bg" *ngIf="searchForm.value.viewType == 'DASHBOARD'">


      <div class="widget-group grey-100-bg p-12" fxLayout="row wrap" fxFlex="100" *fuseIfOnDom [@animateStagger]="{value:'50'}">


        <!-- WIDGET 1 -->
        <fuse-widget [@animate]="{value:'*',params:{y:'100%'}}" class="widget" fxLayout="column" fxFlex="50"
          fxFlex.gt-xs="50" fxFlex.gt-md="20">

          <!-- Front -->
          <div class="fuse-widget-front mat-white-bg mat-elevation-z2" style="border-left: 6px solid blue">
            <div class="pl-16 pr-8 py-16 h-52" fxLayout="row" fxLayoutAlign="space-between center">
              <div class="h1 secondary-text font-weight-500">{{widgets.widget1.title}}</div>
            </div>

            <div class="pt-8 pb-32" fxLayout="column" fxLayoutAlign="center center">
              <div class="blue-fg font-size-42 line-height-42">
                {{widgets.widget1.data.count}}
              </div>

            </div>

            <div class="p-16 grey-50-bg border-top" fxLayout="row" fxLayoutAlign="start center">
              <span class="h4 secondary-text text-truncate">
                {{widgets.widget1.data.extra.label}}:
              </span>
              <span class="h4 ml-8">{{widgets.widget1.data.extra.count}}</span>
            </div>
          </div>
          <!-- / Front -->
        </fuse-widget>
        <!-- / WIDGET 1 -->

        <!-- WIDGET 2 -->
        <fuse-widget [@animate]="{value:'*',params:{y:'100%'}}" class="widget" fxLayout="column" fxFlex="50"
          fxFlex.gt-xs="50" fxFlex.gt-md="20">

          <!-- Front -->
          <div class="fuse-widget-front mat-white-bg mat-elevation-z2" style="border-left: 6px solid rgb(0, 183, 255)">
            <div class="pl-16 pr-8 py-16 h-52" fxLayout="row" fxLayoutAlign="space-between center">
              <div class="h1 secondary-text font-weight-500">{{widgets.widget2.title}}</div>
            </div>

            <div class="pt-8 pb-32" fxLayout="column" fxLayoutAlign="center center">
              <div class="light-blue-200-fg font-size-42 line-height-42">
                {{widgets.widget2.data.count}}
              </div>

            </div>

            <div class="p-16 grey-50-bg border-top" fxLayout="row" fxLayoutAlign="start center">
              <span class="h4 secondary-text text-truncate">
                {{widgets.widget2.data.extra.label}}:
              </span>
              <span class="h4 ml-8">{{widgets.widget2.data.extra.count}}</span>
            </div>
          </div>
          <!-- / Front -->
        </fuse-widget>
        <!-- / WIDGET 2 -->

        <!-- WIDGET 3 -->
        <fuse-widget [@animate]="{value:'*',params:{y:'100%'}}" class="widget" fxLayout="column" fxFlex="50"
          fxFlex.gt-xs="50" fxFlex.gt-md="20">

          <!-- Front -->
          <div class="fuse-widget-front mat-white-bg mat-elevation-z2" style="border-left: 6px solid red">
            <div class="pl-16 pr-8 py-16 h-52" fxLayout="row" fxLayoutAlign="space-between center">
              <div class="h1 secondary-text font-weight-500">{{widgets.widget3.title}}</div>
            </div>

            <div class="pt-8 pb-32" fxLayout="column" fxLayoutAlign="center center">
              <div class="red-200-fg font-size-42 line-height-42">
                {{widgets.widget3.data.count}}
              </div>

            </div>

            <div class="p-16 grey-50-bg border-top" fxLayout="row" fxLayoutAlign="start center">
              <span class="h4 secondary-text text-truncate">
                {{widgets.widget3.data.extra.label}}:
              </span>
              <span class="h4 ml-8">{{widgets.widget3.data.extra.count}}</span>
            </div>
          </div>
          <!-- / Front -->
        </fuse-widget>
        <!-- / WIDGET 3 -->

        <!-- WIDGET 4 -->
        <fuse-widget [@animate]="{value:'*',params:{y:'100%'}}" class="widget" fxLayout="column" fxFlex="50"
          fxFlex.gt-xs="50" fxFlex.gt-md="20">

          <!-- Front -->
          <div class="fuse-widget-front mat-white-bg mat-elevation-z2" style="border-left: 6px solid brown">
            <div class="pl-16 pr-8 py-16 h-52" fxLayout="row" fxLayoutAlign="space-between center">
              <div class="h1 secondary-text font-weight-500">{{widgets.widget4.title}}</div>
            </div>

            <div class="pt-8 pb-32" fxLayout="column" fxLayoutAlign="center center">
              <div class="brown-400-fg font-size-42 line-height-42">
                {{widgets.widget4.data.count}}
              </div>

            </div>

            <div class="p-16 grey-50-bg border-top" fxLayout="row" fxLayoutAlign="start center">
              <span class="h4 secondary-text text-truncate">
                {{widgets.widget4.data.extra.label}}:
              </span>
              <span class="h4 ml-8">{{widgets.widget4.data.extra.count}}</span>
            </div>
          </div>
          <!-- / Front -->
        </fuse-widget>
        <!-- / WIDGET 4 -->

        <!-- WIDGET 6 -->
        <fuse-widget [@animate]="{value:'*',params:{y:'100%'}}" class="widget" fxLayout="column" fxFlex="50"
          fxFlex.gt-xs="50" fxFlex.gt-md="20">

          <!-- Front -->
          <div class="fuse-widget-front mat-white-bg mat-elevation-z2" style="border-left: 6px solid gray">
            <div class="pl-16 pr-8 py-16 h-52" fxLayout="row" fxLayoutAlign="space-between center">
              <div class="h1 secondary-text font-weight-500">{{widgets.widget6.title}}</div>
            </div>

            <div class="pt-8 pb-32" fxLayout="column" fxLayoutAlign="center center">
              <div class="blue-grey-200-fg font-size-42 line-height-42">
                {{widgets.widget6.data.count}}
              </div>

            </div>

            <div class="p-16 grey-50-bg border-top" fxLayout="row" fxLayoutAlign="start center">
              <span class="h4 secondary-text text-truncate">
                {{widgets.widget6.data.extra.label}}:
              </span>
              <span class="h4 ml-8">{{widgets.widget6.data.extra.count}}</span>
            </div>
          </div>
          <!-- / Front -->
        </fuse-widget>
        <!-- / WIDGET 6 -->



        <!-- WIDGET 5 -->
        <fuse-widget [@animate]="{value:'*',params:{y:'100%'}}" fxLayout="row" fxFlex="100">

          <!-- Front -->
          <div class="fuse-widget-front mat-white-bg mat-elevation-z2">

            <div class="px-16 border-bottom" fxLayout="row wrap" fxLayoutAlign="space-between center">
              <div fxFlex="100" fxFlex.gt-sm="33">
                <div fxFlex class="py-16 h3">{{widgets.widget5.title}}</div>
              </div>

            </div>
          <!-- Ativar Modulo -->
            <!-- <div fxLayout="row wrap" fxLayoutAlign="start start">

              <div class="h-420 my-16" fxLayout="row" fxFlex="100" fxFlex.gt-sm="100">
                <ngx-charts-bar-vertical-stacked *fuseIfOnDom [scheme]="widget5.scheme" [results]="this.widgets.widget5.mainChart[this.widget5.currentRange]"
                  [gradient]="widget5.gradient" [xAxis]="widget5.xAxis" [yAxis]="widget5.yAxis" [legend]="widget5.legend"
                  [showXAxisLabel]="widget5.showXAxisLabel" [showYAxisLabel]="widget5.showYAxisLabel" [xAxisLabel]="widget5.xAxisLabel"
                  [yAxisLabel]="widget5.yAxisLabel" (select)="widget5.onSelect($event)">
                </ngx-charts-bar-vertical-stacked>
              </div>

            </div> -->
          </div>
         

        </fuse-widget>
       
      </div>

    </div>

  </div>
  <!-- / CENTER -->
</div>
